/*******************************************************************************
**  DAVE App Name : ADC004       App Version: 1.0.8               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/

/*CODE_BLOCK_BEGIN[ADC004_Conf.c]*/

/*******************************************************************************
 Copyright (c) 2013, Infineon Technologies AG                                 **
 All rights reserved.                                                         **
                                                                              **
 Redistribution and use in source and binary forms, with or without           **
 modification,are permitted provided that the following conditions are met:   **
                                                                              **
 *Redistributions of source code must retain the above copyright notice,      **
 this list of conditions and the following disclaimer.                        **
 *Redistributions in binary form must reproduce the above copyright notice,   **
 this list of conditions and the following disclaimer in the documentation    **
 and/or other materials provided with the distribution.                       **
 *Neither the name of the copyright holders nor the names of its contributors **
 may be used to endorse or promote products derived from this software without**
 specific prior written permission.                                           **
                                                                              **
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  **
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    **
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   **
 ARE  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE   **
 LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR         **
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF         **
 SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS    **
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN      **
 CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)       **
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE   **
 POSSIBILITY OF SUCH DAMAGE.                                                  **
                                                                              **
 To improve the quality of the software, users are encouraged to share        **
 modifications, enhancements or bug fixes with Infineon Technologies AG       **
 dave@infineon.com).                                                          **
                                                                              **
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC1000 Series                                         **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR   : DAVE App Developer                                              **
**                                                                            **
** MAY BE CHANGED BY USER [yes/no]: Yes                                       **
**                                                                            **
** MODIFICATION DATE : Nov 13, 2013                                           **
**                                                                            **
*******************************************************************************/

/*******************************************************************************
**                       Author(s) Identity                                   **
********************************************************************************
**                                                                            **
** Initials     Name                                                          **
** ---------------------------------------------------------------------------**
** CM           DAVE App Developer                                            **
*******************************************************************************/
/**
 * @file  ADC004_Conf.c
 * @App Version ADC004 <1.0.8>
 * @brief This file contains App parameter data as per GUI configurations
 * Change History:
 * Date       version              Details
 * 13-Jun-2013  1.0.0     Initial code added for XMC1100
 * 27-Jun-2013  1.0.2     Help doc updated
 *                        Enable Arbitration slot removed from UI
 * 13-Nov-2013  1.0.4     In GUI Group 0/1 is made as Group A/B and 
 *                        manifest modified as per this change.
 */

#include <DAVE3.h>




ADC004_DynamicDataType ADC004_DynamicHandle =
{
  .State = ADC004_UNINITIALIZED
};

const ADC004_ChannelHandleType ADC004_ChannelAAHandle = {
  .kGroupNo = (uint8_t)0,
  .kChannelNo = (uint8_t)1,
  .kEnable = (uint8_t)1
};

const ADC004_ChannelHandleType ADC004_ChannelABHandle = {
  .kGroupNo = (uint8_t)0,
  .kChannelNo = (uint8_t)2,
  .kEnable = (uint8_t)1
};
const ADC004_ChannelHandleType* ADC004_ChannelHandlePtr[2] = {
  &ADC004_ChannelAAHandle,
  &ADC004_ChannelABHandle,
};
const ADC004_HandleType ADC004_Handle0 =
{
  .kAnaRef =(uint8_t)ADC004_SHS_EXT_REF_UPPER,
  .kAnaControl =(uint8_t)ADC004_SHS_ANALOG_CONVERTER_ON,
  .kGainG0Ch0 = (uint8_t)GAIN_FACTOR_1,
  .kGainG0Ch1 = (uint8_t)GAIN_FACTOR_1,
  .kGainG0Ch2 = (uint8_t)GAIN_FACTOR_1,
  .kGainG0Ch3 = (uint8_t)GAIN_FACTOR_1,
  .kGainG0Ch4 = (uint8_t)GAIN_FACTOR_1,
  .kGainG0Ch5 = (uint8_t)GAIN_FACTOR_1,
  .kGainG0Ch6 = (uint8_t)GAIN_FACTOR_1,
  .kGainG0Ch7 = (uint8_t)GAIN_FACTOR_1,
  .kGainG1Ch0 = (uint8_t)GAIN_FACTOR_1,
  .kGainG1Ch1 = (uint8_t)GAIN_FACTOR_1,
  .kGainG1Ch2 = (uint8_t)GAIN_FACTOR_1,
  .kGainG1Ch3 = (uint8_t)GAIN_FACTOR_1,
  .kGainG1Ch4 = (uint8_t)GAIN_FACTOR_1,
  .kGainG1Ch5 = (uint8_t)GAIN_FACTOR_1,
  .kGainG1Ch6 = (uint8_t)GAIN_FACTOR_1,
  .kGainG1Ch7 = (uint8_t)GAIN_FACTOR_1,
  .kLoopen1 = (uint8_t)0, 
  .kLoopen0 = (uint8_t)0, 
  .kGroupLoop0 = (uint8_t)1, 
  .kGroupLoop1 = (uint8_t)1, 
  .kChLoop1 = (uint8_t)8, 
  .kChLoop0 = (uint8_t)8, 
  .kChannels = (uint8_t)2,
  .kGroup0ChSelect = (uint8_t)6, 
  .kGroup1ChSelect = (uint8_t)0,
  .kGrpAChannels = (uint8_t)2,
  .kGrpBChannels = (uint8_t)0,  
  .kActiveGroups = {(uint8_t)1, (uint8_t)0 },   
  .kActiveChannels = {{(uint8_t)0, (uint8_t)1, (uint8_t)1, (uint8_t)0, (uint8_t)0, (uint8_t)0, (uint8_t)0, (uint8_t)0 },
                      {(uint8_t)0, (uint8_t)0, (uint8_t)0, (uint8_t)0, (uint8_t)0, (uint8_t)0, (uint8_t)0, (uint8_t)0 } 
                       },  
  .kPriority = (uint8_t)ADC004_PRIORITY0,  
  .kResultReadMode = (uint8_t)ADC004_WAIT_FOR_READ,
  .kTriggerMode = (uint8_t)ADC004_NOTRIGGER,
  .kGatingMode = (uint8_t)ADC004_GATING_ENABLED_ALWAYS,
  .kTriggerEn = (uint8_t)0,
  .kAutoScan = (uint8_t)ADC004_AUTOSCAN_DISABLE,
  .kResultControl = (uint8_t)ADC004_LEFT_ALIGN,
  .kResultEvtEnable= (uint8_t)1,
  .kResourceEvtEnable= (uint8_t)0,
  .kIpClassSel = (uint8_t)ADC004_GLOBAL_CLASS0,  
  .VADCGlobalPtr= (VADC_GLOBAL_TypeDef*)VADC,
  .SHSPtr= (SHS_Type*)SHS0,
  .DynamicHandlePtr= &ADC004_DynamicHandle,
 };
 
/*CODE_BLOCK_END*/

