/*******************************************************************************
**  DAVE App Name : UART002       App Version: 1.0.14               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/

/*CODE_BLOCK_BEGIN[UART002_Conf.c]*/

/*******************************************************************************
 Copyright (c) 2013, Infineon Technologies AG                                 **
 All rights reserved.                                                         **
                                                                              **
 Redistribution and use in source and binary forms, with or without           **
 modification,are permitted provided that the following conditions are met:   **
                                                                              **
 *Redistributions of source code must retain the above copyright notice,      **
 this list of conditions and the following disclaimer.                        **
 *Redistributions in binary form must reproduce the above copyright notice,   **
 this list of conditions and the following disclaimer in the documentation    **
 and/or other materials provided with the distribution.                       **
 *Neither the name of the copyright holders nor the names of its contributors **
 may be used to endorse or promote products derived from this software without** 
 specific prior written permission.                                           **
                                                                              **
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  **
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    **
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   **
 ARE  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE   **
 LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR         **
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF         **
 SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS    **
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN      **
 CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)       **
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE   **
 POSSIBILITY OF SUCH DAMAGE.                                                  **
                                                                              **
 To improve the quality of the software, users are encouraged to share        **
 modifications, enhancements or bug fixes with Infineon Technologies AG       **
 dave@infineon.com).                                                          **
                                                                              **
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC4000/XMC1000 Series   			                  **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR   : App Developer                                                   **
**                                                                            **
** MAY BE CHANGED BY USER [yes/no]: Yes                                       **
**                                                                            **
**                                                                            **
*******************************************************************************/
/*
 * Revision History
 * 
 * 17 Apr 2013 v1.0.8   1. Modified the structure UART002_HandleType to add baud
 *                         parameters for the baud rate.
 *                      2. DMA mode handling is disabled for XMC1000 devices 
 *                          as DMA module is not available in XMC1000 devices.     
 */
/**
 * @file   UART002_Conf.c
 *
 * @App    Version UART002 <1.0.14>
 * 
 * @brief  Configuration file generated based on UI settings 
 *         of UART002 App
 *
 */
/*******************************************************************************
 ** INCLUDE FILES                                                             **
 ******************************************************************************/
#include <DAVE3.h>



UART002_DynamicDataType AppDynamicData0; 
const UART002_HandleType UART002_Handle0  = 
{
   .DynamicData = &AppDynamicData0,
   .UartRegs = USIC0_CH0, /* Usic Channel offset value */
   .Mode = (UART_ModeType)0,
   .ChConfig = {
		       (UART_ParityType)0,/* Parity */
		       (UART_StopBitType)0,/* StopBit */
               19200,/*Baud Rate */
               7/* Word Length */
   				},
   .RxFIFOTrigger = 1,/* FIFO Tigger Level */
   .TxFIFOTrigger = 1,/* FIFO Tigger Level */
   .BGR_STEP = (uint16_t)768,  /* Baud Rate Generation step value */
   .BGR_PDIV = (uint16_t)124,   /* Baud Rate Generation  pdiv value */
   .BGR_DCTQ = (uint16_t)9, /* Baud Rate Generation dctq value */   
   .BGR_SP = (uint16_t)6, /* Baud Rate Generation sampling point */
   .BGR_PCTQ = (uint8_t)0  /* Baud Rate Generation pctq value */   
};


/*CODE_BLOCK_END*/


