<?xml version="1.0" encoding="ASCII"?>
<ResourceModel:App xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:ResourceModel="http://www.infineon.com/Davex/Resource.ecore" name="CLK002" description="App to configure System&#xA; and Peripheral Clocks for XMC 1XXX Series Devices." descriptionURL="/doc/html/group___s_c_u___module_system_clocks___c_l_k002_app.html" mode="SHARABLE" URI="http://www.infineon.com/1.0.8/app/clk002/0">
  <upWardMappingList xsi:type="ResourceModel:ProxyResource" href="../../RTOS001/1.0.24/rtos001_0.app#//@consumed.7"/>
  <upWardMappingList xsi:type="ResourceModel:ProxyResource" href="../../ADCGLOB001/1.0.26/adcglob001_0.app#//@consumed.9"/>
  <upWardMappingList xsi:type="ResourceModel:ProxyResource" href="../../UART002/1.0.14/uart002_0.app#//@consumed.5"/>
  <upWardMappingList xsi:type="ResourceModel:ProxyResource" href="../../CCU4GLOBAL/1.0.20/ccu4global_0.app#//@consumed.2"/>
  <provided xsi:type="ResourceModel:VirtualSignal" name="DCO clock out" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_clkout_vs" requiredSignalResource="DCO_uri/clkout">
    <localValue xsi:type="ResourceModel:StringValue" value="-1"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="-1"/>
  </provided>
  <provided xsi:type="ResourceModel:VirtualSignal" name="frtc clock input" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_frtc_vs" requiredSignalResource="clk_uri/frtc">
    <localValue xsi:type="ResourceModel:StringValue" value="-1"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="-1"/>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Peripheral Clock Selection - PCLK" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;clk_uri/clkcr/pclksel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;clk_uri/clkcr/pclksel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwpclkselection" downWardmappedList="//@consumed.29">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>CCU8/POSIF0/CCU40/MATH/BCCU0 Uses PCLK</toolTipHelpDescription>
    <item name="PCLK = MCLK" evalFunction="      &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value3 = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;clk_uri/clkcr/pclksel&quot;);&#xD;&#xA;&#xD;&#xA;              &#x9;if (value3 == 1 ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(Res4,0);&#xD;&#xA;      &#x9;        &#x9;var tempRespclk = SCM.getResource(&quot;PCLKselBit&quot;);&#xD;&#xA;        &#x9;    &#x9;SCM.setDoubleValue(tempRespclk,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;InputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var InputFreq1 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var userfreq = &#x9;2*InputFreq1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var freq_fact=64000/userfreq;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var i_div=Math.floor(freq_fact);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (i_div==256)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;i_div=i_div-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;            var Res3 = SCM.getResource(&quot;clk_uri/clkcr/idiv&quot;); &#xD;&#xA;&#x9;&#x9;            SCM.setIntValue(Res3,i_div);&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var temp_f_div=(freq_fact-i_div)*256;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (i_div==255)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;temp_f_div=0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var f_div;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempfdivfact;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (temp_f_div==0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;f_div=0;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;tempfdivfact = 0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;f_div=Math.floor(temp_f_div);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;tempfdivfact = f_div/256;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;            var Res4 = SCM.getResource(&quot;clk_uri/clkcr/fdiv&quot;); &#xD;&#xA;&#x9;&#x9;            SCM.setIntValue(Res4,f_div);&#xD;&#xA;&#x9;&#x9; &#xD;&#xA;&#x9;&#x9;           &#x9;var tempidivfact = i_div;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var DinominatorFact = tempfdivfact+tempidivfact;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ActDinomiFact = DinominatorFact*2;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var MCLK = 64000/ActDinomiFact;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;MCLK = MCLK/1000;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;ActualMCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,MCLK);&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;ActualPCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,MCLK);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;          &#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;else if (value3 == 0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;            &#x9;SCM.setIntValue(Res4,1);&#xD;&#xA;&#x9;  &#x9;        &#x9;var tempRespclk = SCM.getResource(&quot;PCLKselBit&quot;);&#xD;&#xA;&#x9;    &#x9;    &#x9;SCM.setDoubleValue(tempRespclk,1);&#xD;&#xA;&#x9;    &#x9;   &#x9;}              &#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;            &#xD;&#xA;&#x9;&#x9;&#x9;function BackwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;clk_uri/clkcr/pclksel&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value3 = SCM.getIntValue(Res4);&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;          &#x9;if (value3 == 1 ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;            &#x9;SCM.setIntValue(currentResource,0);&#xD;&#xA;&#x9;          &#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;else if (value3 == 0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;            &#x9;SCM.setIntValue(currentResource,1);&#xD;&#xA;&#x9;    &#x9;   &#x9;}              &#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;            " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwpclkselection/0" downWardmappedList="//@consumed.29 //@consumed.19 //@consumed.30 //@consumed.31 //@consumed.16 //@consumed.15" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>PCLK is equal to MCLK</toolTipHelpDescription>
    </item>
    <item name="PCLK = 2*MCLK" evalFunction="      &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value3 = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;clk_uri/clkcr/pclksel&quot;);&#xD;&#xA;&#xD;&#xA;              &#x9;if (value3 == 1 ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(Res4,1);&#xD;&#xA;      &#x9;        &#x9;var tempRespclk = SCM.getResource(&quot;PCLKselBit&quot;);&#xD;&#xA;        &#x9;    &#x9;SCM.setDoubleValue(tempRespclk,1);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;InputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var InputFreq1 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var userfreq = &#x9;2*InputFreq1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var freq_fact=64000/userfreq;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var i_div=Math.floor(freq_fact);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (i_div==256)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;i_div=i_div-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;            var Res3 = SCM.getResource(&quot;clk_uri/clkcr/idiv&quot;); &#xD;&#xA;&#x9;&#x9;            SCM.setIntValue(Res3,i_div);&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var temp_f_div=(freq_fact-i_div)*256;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (i_div==255)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;temp_f_div=0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var f_div;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempfdivfact;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (temp_f_div==0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;f_div=0;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;tempfdivfact = 0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;f_div=Math.floor(temp_f_div);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;tempfdivfact = f_div/256;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;            var Res4 = SCM.getResource(&quot;clk_uri/clkcr/fdiv&quot;); &#xD;&#xA;&#x9;&#x9;            SCM.setIntValue(Res4,f_div);&#xD;&#xA;&#x9;&#x9; &#xD;&#xA;&#x9;&#x9;           &#x9;var tempidivfact = i_div;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var DinominatorFact = tempfdivfact+tempidivfact;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ActDinomiFact = DinominatorFact*2;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var MCLK = 64000/ActDinomiFact;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;MCLK=MCLK/1000;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;ActualMCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,MCLK);&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;            var PCLK;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;PCLK = 2*MCLK;&#xD;&#xA;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;ActualPCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,PCLK);&#xD;&#xA;&#xD;&#xA;              &#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;else if (value3 == 0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(Res4,0);&#xD;&#xA;      &#x9;        &#x9;var tempRespclk = SCM.getResource(&quot;PCLKselBit&quot;);&#xD;&#xA;        &#x9;    &#x9;SCM.setDoubleValue(tempRespclk,0);&#xD;&#xA;        &#x9;   &#x9;}              &#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;            &#xD;&#xA;&#x9;&#x9;&#x9;function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;clk_uri/clkcr/pclksel&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value3 = SCM.getIntValue(Res4);&#xD;&#xA;&#xD;&#xA;              &#x9;if (value3 == 1 ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(currentResource,1);&#xD;&#xA;              &#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;else if (value3 == 0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(currentResource,0);&#xD;&#xA;        &#x9;   &#x9;}              &#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;              " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwpclkselection/1" downWardmappedList="//@consumed.29 //@consumed.19" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>PCLK is double of MCLK</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Desired Frequency" evalFunction="&#xD;&#xA;        function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;InputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var InputFreq1 = SCM.getDoubleValue(currentResource);&#xD;&#xA;       &#x9;&#x9;SCM.setDoubleValue(Res4,InputFreq1);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var userfreq = &#x9;2*InputFreq1;&#xD;&#xA;&#x9;&#x9;&#x9;var freq_fact=64000/userfreq;&#xD;&#xA;&#x9;&#x9;&#x9;var i_div=Math.floor(freq_fact);&#xD;&#xA;&#x9;&#x9;&#x9;if (i_div==256)&#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;i_div=i_div-1;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;            var Res3 = SCM.getResource(&quot;clk_uri/clkcr/idiv&quot;); &#xD;&#xA;            SCM.setIntValue(Res3,i_div);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var temp_f_div=(freq_fact-i_div)*256;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;if (i_div==255)&#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;temp_f_div=0;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var f_div;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;var tempfdivfact;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;if (temp_f_div==0)&#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;f_div=0;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;tempfdivfact = 0;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;else &#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;f_div=Math.floor(temp_f_div);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;tempfdivfact = f_div/256;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;            var Res4 = SCM.getResource(&quot;clk_uri/clkcr/fdiv&quot;); &#xD;&#xA;            SCM.setIntValue(Res4,f_div);&#xD;&#xA; &#xD;&#xA;           &#x9;var tempidivfact = i_div;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var DinominatorFact = tempfdivfact+tempidivfact;&#xD;&#xA;&#x9;&#x9;&#x9;var ActDinomiFact = DinominatorFact*2;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var MCLK = 64000/ActDinomiFact;&#xD;&#xA;&#x9;&#x9;&#x9;MCLK = MCLK/1000;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;ActualMCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,MCLK);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;PCLKselBit&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value = SCM.getDoubleValue(tempRes);&#xD;&#xA;            var PCLK;&#xD;&#xA;        &#x9;&#xD;&#xA;            if (value == 1 ) &#xD;&#xA; &#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;PCLK = 2* MCLK;&#xD;&#xA;&#x9;&#x9;&#x9;}            &#xD;&#xA;&#x9;       &#x9;else&#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;PCLK = MCLK;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;ActualPCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,PCLK);&#xD;&#xA;    &#x9;}&#xD;&#xA;        &#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res5 = SCM.getResource(&quot;InputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value5 = SCM.getDoubleValue(Res5);&#xD;&#xA;           &#x9;&#x9;SCM.setDoubleValue(currentResource,value5);&#xD;&#xA;&#x9;&#x9; }&#xD;&#xA;        " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_irwdesfreqsystemint" downWardmappedList="//@consumed.17 //@consumed.30 //@consumed.31 //@consumed.16 //@consumed.15" maxValue="7D00" minValue="7D">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="7D00"/>
    <localValue xsi:type="ResourceModel:StringValue" value="7D00"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="7d00"/>
    <toolTipHelpDescription>Enter Desired Main Clock Frequency - MCLK,
Valid clock range is 125 KHz to 32000 KHz.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Configured PCLK" evalFunction="&#xD;&#xA;&#xD;&#xA;        function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;InputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value3 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res3 = SCM.getResource(&quot;PCLKselBit&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value2 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;        }&#xD;&#xA;        &#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res5 = SCM.getResource(&quot;ActualPCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value5 = SCM.getDoubleValue(Res5);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(currentResource,value5);       &#xD;&#xA;&#xD;&#xA;&#x9;&#x9; }&#xD;&#xA;&#xD;&#xA;        " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_irpclk" maxValue="40" minValue="00">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="20"/>
    <upWardMappingList xsi:type="ResourceModel:ProxyResource" href="../../RTOS001/1.0.24/rtos001_0.app#//@consumed.18"/>
    <upWardMappingList xsi:type="ResourceModel:ProxyResource" href="../../ADCGLOB001/1.0.26/adcglob001_0.app#//@consumed.29"/>
    <upWardMappingList xsi:type="ResourceModel:ProxyResource" href="../../CCU4GLOBAL/1.0.20/ccu4global_0.app#//@consumed.8"/>
    <localValue xsi:type="ResourceModel:StringValue" value="20"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="20"/>
    <toolTipHelpDescription>Configured PCLK</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Standyby Clock" evalFunction="&#xD;&#xA;        function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#x9;&#x9;&#x9;    var Res4 = SCM.getResource(&quot;InputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;    var Res3 = SCM.getResource(&quot;PCLKselBit&quot;);&#xD;&#xA;        }&#xD;&#xA;        &#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#x9;&#x9;&#x9;    var Res5 = SCM.getResource(&quot;ActualMCLK&quot;);&#xD;&#xA;&#x9; &#x9;    }&#xD;&#xA;        " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_standbyclock" maxValue="8000" minValue="0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8000"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="8000"/>
    <toolTipHelpDescription>The Standby Clock is asynchronous to the MCLK and PCLK and it is running in 32.768 KHz which is mostly being used by RTC and WDT modules.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Configured MCLK" evalFunction="&#xD;&#xA;        function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;InputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value3 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res3 = SCM.getResource(&quot;PCLKselBit&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value2 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;        }&#xD;&#xA;        &#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res5 = SCM.getResource(&quot;ActualMCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value5 = SCM.getDoubleValue(Res5);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(currentResource,value5);       &#xD;&#xA;&#x9; &#x9;}&#xD;&#xA;        " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_irmclk" maxValue="20" minValue="00">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="20"/>
    <upWardMappingList xsi:type="ResourceModel:ProxyResource" href="../../UART002/1.0.14/uart002_0.app#//@consumed.35"/>
    <localValue xsi:type="ResourceModel:StringValue" value="20"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="20"/>
    <toolTipHelpDescription>Configured MCLK</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="RTC Clock Selection" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;rtc_clockseldummy&quot;); &#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              SCM.setIntValue(Res,value);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var dep = &quot;DependentApp&quot;;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var DepRes0 = SCM.getResource(&quot;analogcompapp&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var DepRes1 = SCM.getResource(&quot;eruapp&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setStringValue(DepRes0,dep);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setStringValue(DepRes1,dep);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;rtc_clockseldummy&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwrtcclockselection" downWardmappedList="//@consumed.18 //@consumed.14 //@consumed.13">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>RTC Clock Selection</toolTipHelpDescription>
    <item name="32.768kHz Standby Clock for RTC" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var dep = &quot;DependentApp&quot;;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var DepRes0 = SCM.getResource(&quot;analogcompapp&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var DepRes1 = SCM.getResource(&quot;eruapp&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setStringValue(DepRes0,dep);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setStringValue(DepRes1,dep);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;              if (value0 === 0) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value0 == -1){&#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }        &#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwrtcclockselection/0" downWardmappedList="//@consumed.18 //@consumed.14 //@consumed.13" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>RTC Clock Selection</toolTipHelpDescription>
    </item>
    <item name="32.768kHz External Clock From ERU0 for RTC" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,1);    &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var dep = &quot;DependentApp&quot;;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var DepRes0 = SCM.getResource(&quot;analogcompapp&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var DepRes1 = SCM.getResource(&quot;eruapp&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setStringValue(DepRes0,dep);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setStringValue(DepRes1,dep);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#xD;&#xA;              if (value0 === 1) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value0 == -1){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }  &#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwrtcclockselection/1" downWardmappedList="//@consumed.18 //@consumed.14 //@consumed.13" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>32.768kHz External Clock From ERU0 for RTC</toolTipHelpDescription>
    </item>
    <item name="32.768kHz external clock from Analog Comparator" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,2);&#xD;&#xA;      &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;&#xD;&#xA;              }              &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var dep = &quot;DependentApp&quot;;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var DepRes0 = SCM.getResource(&quot;analogcompapp&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var DepRes1 = SCM.getResource(&quot;eruapp&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setStringValue(DepRes0,dep);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;SCM.setStringValue(DepRes1,dep);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;&#xD;&#xA; &#x9;&#x9;&#x9;  var XMC1xxx=SCM.getSoftwareId().substring(0,2).compareTo(&quot;11&quot;);  &#xD;&#xA;  &#x9;&#x9;&#x9;  if(XMC1xxx==0){&#xD;&#xA;              var reserved = SCM.getReserverd();&#xD;&#xA;        &#x9;  SCM.setValue(currentResource,reserved);&#xD;&#xA;&#x9;&#x9;&#x9;  }&#xD;&#xA;&#x9;&#x9;&#x9;  else&#xD;&#xA;&#x9;&#x9;&#x9;  {&#x9;&#xD;&#xA;                 var Res0 = SCM.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;&#xD;&#xA;                 var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#xD;&#xA;                 if (value0 === 2) { &#xD;&#xA;                   SCM.setIntValue(currentResource,1);&#xD;&#xA;                 } else if (value0 == -1){&#xD;&#xA;                   SCM.setIntValue(currentResource,0);&#xD;&#xA;                 }&#xD;&#xA;                   else {&#xD;&#xA;                   SCM.setIntValue(currentResource,0);&#xD;&#xA;                 }&#xD;&#xA;&#x9;&#x9;&#x9; } &#xD;&#xA;            }  &#xD;&#xA;            " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwrtcclockselection/2" downWardmappedList="//@consumed.18 //@consumed.14 //@consumed.13" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:Reserved" value="Reserved"/>
      <toolTipHelpDescription>32.768kHz external clock from Analog Comparator</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Peripheral Frequency - PCLK during BootROM Firmware Execution" evalFunction="&#xD;&#xA;        function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#x9;          var Res = SCM.getResource(&quot;SSWpclksel&quot;); &#xD;&#xA;&#x9;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;          SCM.setIntValue(Res,value);&#xD;&#xA;        }&#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;              var Res = SCM.getResource(&quot;SSWpclksel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;        }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswpclkselection" downWardmappedList="//@consumed.24">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>Frequency for Peripheral, this frequency is used during BootROM Firmware Execution</toolTipHelpDescription>
    <item name="PCLK = MCLK" evalFunction="      &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value3 = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWpclksel&quot;);&#xD;&#xA;&#xD;&#xA;              &#x9;if (value3 == 1 ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(Res4,0);&#xD;&#xA;      &#x9;        &#x9;var tempRespclk = SCM.getResource(&quot;SSWPCLKselBit&quot;);&#xD;&#xA;        &#x9;    &#x9;SCM.setDoubleValue(tempRespclk,0);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWInputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var InputFreq1 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var userfreq = &#x9;2*InputFreq1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var freq_fact=64000/userfreq;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var i_div=Math.floor(freq_fact);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (i_div==256)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;i_div=i_div-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var Res3 = SCM.getResource(&quot;SSWidiv&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Res3,i_div);&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var temp_f_div=(freq_fact-i_div)*256;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (i_div==255)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;temp_f_div=0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var f_div;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempfdivfact;&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (temp_f_div==0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;f_div=0;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;tempfdivfact = 0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;f_div=Math.floor(temp_f_div);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;tempfdivfact = f_div/256;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWfdiv&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Res4,f_div);&#xD;&#xA;&#x9;&#x9; &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempidivfact = i_div;&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var DinominatorFact = tempfdivfact+tempidivfact;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ActDinomiFact = DinominatorFact*2;&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var MCLK = 64000/ActDinomiFact;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;MCLK = MCLK/1000;&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;SSWActualMCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,MCLK);&#xD;&#xA;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;SSWActualPCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,MCLK);&#xD;&#xA;              &#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;else if (value3 == 0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(Res4,1);&#xD;&#xA;      &#x9;        &#x9;var tempRespclk = SCM.getResource(&quot;SSWPCLKselBit&quot;);&#xD;&#xA;        &#x9;    &#x9;SCM.setDoubleValue(tempRespclk,1);&#xD;&#xA;        &#x9;   &#x9;}              &#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;            &#xD;&#xA;&#x9;&#x9;&#x9;function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWpclksel&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value3 = SCM.getIntValue(Res4);&#xD;&#xA;&#xD;&#xA;              &#x9;if (value3 == 1 ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(currentResource,0);&#xD;&#xA;              &#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;else if (value3 == 0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(currentResource,1);&#xD;&#xA;        &#x9;   &#x9;}              &#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;            " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswpclkselection/0" downWardmappedList="//@consumed.24 //@consumed.26 //@consumed.22 //@consumed.23 //@consumed.21 //@consumed.20" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>PCLK is equal to MCLK</toolTipHelpDescription>
    </item>
    <item name="PCLK = 2*MCLK" evalFunction="      &#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value3 = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWpclksel&quot;);&#xD;&#xA;&#xD;&#xA;              &#x9;if (value3 == 1 ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(Res4,1);&#xD;&#xA;      &#x9;        &#x9;var tempRespclk = SCM.getResource(&quot;SSWPCLKselBit&quot;);&#xD;&#xA;        &#x9;    &#x9;SCM.setDoubleValue(tempRespclk,1);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWInputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var InputFreq1 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var userfreq = &#x9;2*InputFreq1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var freq_fact=64000/userfreq;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var i_div=Math.floor(freq_fact);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (i_div==256)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;i_div=i_div-1;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var Res3 = SCM.getResource(&quot;SSWidiv&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Res3,i_div);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var temp_f_div=(freq_fact-i_div)*256;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (i_div==255)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;temp_f_div=0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var f_div;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempfdivfact;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if (temp_f_div==0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;f_div=0;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;tempfdivfact = 0;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;else &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;f_div=Math.floor(temp_f_div);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;tempfdivfact = f_div/256;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWfdiv&quot;); &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setIntValue(Res4,f_div);&#xD;&#xA;&#x9;&#x9; &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempidivfact = i_div;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var DinominatorFact = tempfdivfact+tempidivfact;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var ActDinomiFact = DinominatorFact*2;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var MCLK = 64000/ActDinomiFact;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;MCLK=MCLK/1000;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;SSWActualMCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,MCLK);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var PCLK;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;PCLK = 2*MCLK;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;SSWActualPCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,PCLK);&#xD;&#xA;&#xD;&#xA;              &#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;else if (value3 == 0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(Res4,0);&#xD;&#xA;      &#x9;        &#x9;var tempRespclk = SCM.getResource(&quot;SSWPCLKselBit&quot;);&#xD;&#xA;        &#x9;    &#x9;SCM.setDoubleValue(tempRespclk,0);&#xD;&#xA;        &#x9;   &#x9;}              &#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;            &#xD;&#xA;&#x9;&#x9;&#x9;function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWpclksel&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value3 = SCM.getIntValue(Res4);&#xD;&#xA;&#xD;&#xA;              &#x9;if (value3 == 1 ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(currentResource,1);&#xD;&#xA;              &#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;else if (value3 == 0)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;                &#x9;SCM.setIntValue(currentResource,0);&#xD;&#xA;        &#x9;   &#x9;}              &#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;            " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswpclkselection/1" downWardmappedList="//@consumed.24 //@consumed.26" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>PCLK is double of MCLK</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Desired MCLK during BootROM Firmware Execution" evalFunction="&#xD;&#xA;        function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWInputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var InputFreq1 = SCM.getDoubleValue(currentResource);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(Res4,InputFreq1);&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var userfreq = &#x9;2*InputFreq1;&#xD;&#xA;&#x9;&#x9;&#x9;var freq_fact=64000/userfreq;&#xD;&#xA;&#x9;&#x9;&#x9;var i_div=Math.floor(freq_fact);&#xD;&#xA;&#x9;&#x9;&#x9;if (i_div==256)&#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;i_div=i_div-1;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;            var Res3 = SCM.getResource(&quot;SSWidiv&quot;); &#xD;&#xA;            SCM.setIntValue(Res3,i_div);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var temp_f_div=(freq_fact-i_div)*256;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;if (i_div==255)&#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;temp_f_div=0;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var f_div;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;var tempfdivfact;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;if (temp_f_div==0)&#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;f_div=0;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;tempfdivfact = 0;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;else &#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;f_div=Math.floor(temp_f_div);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;tempfdivfact = f_div/256;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;            var Res4 = SCM.getResource(&quot;SSWfdiv&quot;); &#xD;&#xA;            SCM.setIntValue(Res4,f_div);&#xD;&#xA; &#xD;&#xA;           &#x9;var tempidivfact = i_div;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var DinominatorFact = tempfdivfact+tempidivfact;&#xD;&#xA;&#x9;&#x9;&#x9;var ActDinomiFact = DinominatorFact*2;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var MCLK = 64000/ActDinomiFact;&#xD;&#xA;&#x9;&#x9;&#x9;MCLK = MCLK/1000;&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;SSWActualMCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,MCLK);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;SSWPCLKselBit&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value = SCM.getDoubleValue(tempRes);&#xD;&#xA;            var PCLK;&#xD;&#xA;        &#x9;&#xD;&#xA;            if (value == 1 ) &#xD;&#xA; &#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;PCLK = 2* MCLK;&#xD;&#xA;&#x9;&#x9;&#x9;}            &#xD;&#xA;&#x9;       &#x9;else&#xD;&#xA;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;PCLK = MCLK;&#xD;&#xA;&#x9;&#x9;&#x9;}&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var tempRes = SCM.getResource(&quot;SSWActualPCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(tempRes,PCLK);&#xD;&#xA;   &#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;        }&#xD;&#xA;        &#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var Res5 = SCM.getResource(&quot;SSWInputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;var value5 = SCM.getDoubleValue(Res5);&#xD;&#xA;           &#x9;&#x9;SCM.setDoubleValue(currentResource,value5);&#xD;&#xA;&#x9;&#x9;}&#xD;&#xA;        " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_irwsswdesfreqsystemint" downWardmappedList="//@consumed.25 //@consumed.22 //@consumed.23 //@consumed.21 //@consumed.20" maxValue="7D00" minValue="7D0">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="1F40"/>
    <localValue xsi:type="ResourceModel:StringValue" value="1F40"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f40"/>
    <toolTipHelpDescription>Enter Desired MCLK Frequency,
valid clock range is 2000 KHz to 32000 KHz.
This frequency will used during BootROM Firmware Execution.</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Configured PCLK during BootROM Firmware Execution" evalFunction="&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;function ForwardMapping()&#xD;&#xA;&#x9;&#x9;{&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWInputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value3 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res3 = SCM.getResource(&quot;SSWPCLKselBit&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value2 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;}&#xD;&#xA;        &#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res5 = SCM.getResource(&quot;SSWActualPCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value5 = SCM.getDoubleValue(Res5);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(currentResource,value5);       &#xD;&#xA;&#xD;&#xA;&#x9;&#x9; }&#xD;&#xA;&#xD;&#xA;        " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_irsswpclk" maxValue="40" minValue="00">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="8"/>
    <toolTipHelpDescription>Configured PCLK during BootROM Firmware Execution</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:IntegerParameter" name="Configured MCLK during BootROM Firmware Execution" evalFunction="&#xD;&#xA;        function ForwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#x9;&#x9;&#x9;var Res4 = SCM.getResource(&quot;SSWInputFreq&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value3 = SCM.getDoubleValue(Res4);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res3 = SCM.getResource(&quot;SSWPCLKselBit&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value2 = SCM.getDoubleValue(Res3);&#xD;&#xA;&#xD;&#xA;        }&#xD;&#xA;        &#xD;&#xA;        function BackwardMapping()&#xD;&#xA;        {&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;var Res5 = SCM.getResource(&quot;SSWActualMCLK&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;var value5 = SCM.getDoubleValue(Res5);&#xD;&#xA;&#x9;&#x9;&#x9;SCM.setDoubleValue(currentResource,value5);       &#xD;&#xA;&#x9; &#x9;}&#xD;&#xA;        " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_irsswmclk" maxValue="20" minValue="00">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="8"/>
    <localValue xsi:type="ResourceModel:StringValue" value="8"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="8"/>
    <toolTipHelpDescription>Configured MCLK during BootROM Firmware Execution</toolTipHelpDescription>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="RTC Clock Selection during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;SSWrtcclksel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res = SCM.getResource(&quot;SSWrtcclksel&quot;); &#xD;&#xA;              var value = SCM.getIntValue(Res); &#xD;&#xA;              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswrtcclockselection" downWardmappedList="//@consumed.27">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <toolTipHelpDescription>RTC Clock Selection</toolTipHelpDescription>
    <item name="32.768kHz Standby Clock for RTC" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;              if (value0 === 0) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value0 == -1){&#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }        &#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswrtcclockselection/0" downWardmappedList="//@consumed.27" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <localValue xsi:type="ResourceModel:StringValue" value="1"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
      <toolTipHelpDescription>RTC Clock Selection</toolTipHelpDescription>
    </item>
    <item name="32.768kHz External Clock From ERU0 for RTC" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,1);    &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#xD;&#xA;              if (value0 === 1) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value0 == -1){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }  &#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswrtcclockselection/1" downWardmappedList="//@consumed.27" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>32.768kHz External Clock From ERU0 for RTC</toolTipHelpDescription>
    </item>
    <item name="32.768kHz external clock from ACMP0" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,2);&#xD;&#xA;      &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#xD;&#xA;              if (value0 === 2) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value0 == -1){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }  &#xD;&#xA;            " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswrtcclockselection/2" downWardmappedList="//@consumed.27" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>32.768kHz external clock from ACMP0</toolTipHelpDescription>
    </item>
    <item name="32.768kHz external clock from ACMP1" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,3);      &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;              if (value0 === 3) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value0 == -1){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }&#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswrtcclockselection/3" downWardmappedList="//@consumed.27" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>32.768kHz external clock from ACMP1</toolTipHelpDescription>
    </item>
    <item name="32.768kHz external clock from ACMP2" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,4);      &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;SSWrtcclksel&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;              if (value0 === 4) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } else if (value0 == -1){&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }&#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswrtcclockselection/4" downWardmappedList="//@consumed.27" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>32.768kHz external clock from ACMP2</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - VADC during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingvadc" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection- VADC</toolTipHelpDescription>
    <item name="Disable Gating of VADC Clock" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_vadcshs/cgat_clr&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,1);&#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_vadcshs/cgat_clr&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;              if (value0 === 1) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } &#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }        &#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingvadc/0" downWardmappedList="//@consumed.33" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of VADC Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - CCU8 during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingccu8" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of CCU8 Clock" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_ccu8/cgat_clr&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,1);    &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_ccu8/cgat_clr&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#xD;&#xA;              if (value0 === 1) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } &#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }  &#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingccu8/0" downWardmappedList="//@consumed.34" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of CCU8 Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - CCU4 during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingccu4" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of CCU4 Clock" evalFunction="&#xD;&#xA;          function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_ccu4/cgat_clr&quot;);&#xD;&#xA;&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,1);&#xD;&#xA;      &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_ccu4/cgat_clr&quot;);&#xD;&#xA;&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#xD;&#xA;              if (value0 === 1) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } &#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }  &#xD;&#xA;            " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingccu4/0" downWardmappedList="//@consumed.35" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of CCU4 Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - USIC0 during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingusic0 usic0" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of USIC0 Clock" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_usic/cgat_clr&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,1);      &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_usic/cgat_clr&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;              if (value0 === 1) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } &#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }&#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingusic0 usic0/0" downWardmappedList="//@consumed.36" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of USIC0 Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - BCCU0 during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingbccu0" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of BCCU0 Clock" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var value = SCM.getIntValue(currentResource);&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_bccu/cgat_clr&quot;);&#xD;&#xA;              if (value == 1 ) {&#xD;&#xA;                SCM.setIntValue(Res0,1);      &#xD;&#xA;              } else if (value === 0) {&#xD;&#xA;                SCM.setIntValue(Res0,0);&#xD;&#xA;              }              &#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;              var Res0 = SCM.getResource(&quot;clkgating_bccu/cgat_clr&quot;);&#xD;&#xA;              var value0 = SCM.getIntValue(Res0);&#xD;&#xA;              if (value0 === 1) { &#xD;&#xA;                SCM.setIntValue(currentResource,1);&#xD;&#xA;              } &#xD;&#xA;              else {&#xD;&#xA;                SCM.setIntValue(currentResource,0);&#xD;&#xA;              }&#xD;&#xA;            }&#xD;&#xA;          " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingbccu0/0" downWardmappedList="//@consumed.37" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of BCCU0 Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - LEDTS0 during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingledts0" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of LEDTS0 Clock" evalFunction="&#xD;&#xA;&#x9;        function ForwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_ledts0/cgat_clr&quot;);&#xD;&#xA;&#x9;          if (value == 1 ) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,1);      &#xD;&#xA;&#x9;          } else if (value === 0) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,0);&#xD;&#xA;&#x9;          }              &#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;        function BackwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_ledts0/cgat_clr&quot;);&#xD;&#xA;&#x9;          var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#x9;          if (value0 === 1) { &#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,1);&#xD;&#xA;&#x9;          }&#xD;&#xA;&#x9;          else {&#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,0);&#xD;&#xA;&#x9;          }&#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;      " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingledts0/0" downWardmappedList="//@consumed.38" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of LEDTS0 Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - LEDTS1 during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingledts1" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of LEDTS1 Clock" evalFunction="&#xD;&#xA;&#x9;        function ForwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_ledts1/cgat_clr&quot;);&#xD;&#xA;&#x9;          if (value == 1 ) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,1);      &#xD;&#xA;&#x9;          } else if (value === 0) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,0);&#xD;&#xA;&#x9;          }              &#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;        function BackwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_ledts1/cgat_clr&quot;);&#xD;&#xA;&#x9;          var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#x9;          if (value0 === 1) { &#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,1);&#xD;&#xA;&#x9;          }&#xD;&#xA;&#x9;          else {&#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,0);&#xD;&#xA;&#x9;          }&#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;      " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingledts1/0" downWardmappedList="//@consumed.39" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of LEDTS1 Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - POSIF0 during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingposif0" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of POSIF0 Clock" evalFunction="&#xD;&#xA;&#x9;        function ForwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_posif/cgat_clr&quot;);&#xD;&#xA;&#x9;          if (value == 1 ) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,1);      &#xD;&#xA;&#x9;          } else if (value === 0) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,0);&#xD;&#xA;&#x9;          }              &#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;        function BackwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_posif/cgat_clr&quot;);&#xD;&#xA;&#x9;          var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#x9;          if (value0 === 1) { &#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,1);&#xD;&#xA;&#x9;          }&#xD;&#xA;&#x9;          else {&#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,0);&#xD;&#xA;&#x9;          }&#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;      " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingposif0/0" downWardmappedList="//@consumed.40" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of POSIF0 Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - MATH during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingmath" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of MATH Clock" evalFunction="&#xD;&#xA;&#x9;        function ForwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_math/cgat_clr&quot;);&#xD;&#xA;&#x9;          if (value == 1 ) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,1);      &#xD;&#xA;&#x9;          } else if (value === 0) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,0);&#xD;&#xA;&#x9;          }              &#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;        function BackwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#xD;&#xA; &#x9;&#x9;&#x9;  var XMC1xxx=SCM.getSoftwareId().substring(0,9).compareTo(&quot;12.0103.9&quot;);&#xD;&#xA;   &#x9;&#x9;&#x9;  var XMC2xxx=SCM.getSoftwareId().substring(0,9).compareTo(&quot;13.0102.7&quot;);&#xD;&#xA;  &#x9;&#x9;&#x9;  if((XMC1xxx==0)|(XMC2xxx==0)){&#xD;&#xA;&#xD;&#xA;&#x9;             var Res0 = SCM.getResource(&quot;clkgating_math/cgat_clr&quot;);&#xD;&#xA;&#x9;             var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#x9;             if (value0 === 1) { &#xD;&#xA;&#x9;                SCM.setIntValue(currentResource,1);&#xD;&#xA;&#x9;                } &#xD;&#xA;&#x9;             else {&#xD;&#xA;&#x9;                 SCM.setIntValue(currentResource,0);&#xD;&#xA;     &#x9;             }&#xD;&#xA;&#x9;&#x9;&#x9;  }&#xD;&#xA;&#x9;&#x9;&#x9;  else&#xD;&#xA;&#x9;&#x9;&#x9;  {&#x9;&#xD;&#xA;              var reserved = SCM.getReserverd();&#xD;&#xA;        &#x9;  SCM.setValue(currentResource,reserved);&#xD;&#xA;&#xD;&#xA;&#x9;&#x9;&#x9;  }&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;      " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingmath/0" downWardmappedList="//@consumed.41" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:Reserved" value="Reserved"/>
      <toolTipHelpDescription>Disable Gating of MATH Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - WDT during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingwdt" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of WDT Clock" evalFunction="&#xD;&#xA;&#x9;        function ForwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_wdt/cgat_clr&quot;);&#xD;&#xA;&#x9;          if (value == 1 ) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,1);      &#xD;&#xA;&#x9;          } else if (value === 0) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,0);&#xD;&#xA;&#x9;          }              &#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;        function BackwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_wdt/cgat_clr&quot;);&#xD;&#xA;&#x9;          var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#x9;          if (value0 === 1) { &#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,1);&#xD;&#xA;&#x9;          } &#xD;&#xA;&#x9;          else {&#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,0);&#xD;&#xA;&#x9;          }&#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;      " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingwdt/0" downWardmappedList="//@consumed.42" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of WDT Clock</toolTipHelpDescription>
    </item>
  </provided>
  <provided xsi:type="ResourceModel:EnumerationParameter" name="Select Clock Gating - RTC during BootROM Firmware Execution" evalFunction="&#xD;&#xA;            function ForwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(currentResource);&#xD;&#xA;//              SCM.setIntValue(Res,value);&#xD;&#xA;            }&#xD;&#xA;            function BackwardMapping()&#xD;&#xA;            {&#xD;&#xA;//              var Res = SCM.getResource(&quot;SSWCGat&quot;); &#xD;&#xA;//              var value = SCM.getIntValue(Res); &#xD;&#xA;//              SCM.setIntValue(currentResource,value);&#xD;&#xA;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingrtc" multipleSelections="true">
    <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <localValue xsi:type="ResourceModel:StringValue" value="0"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="0"/>
    <toolTipHelpDescription>Peripherial Clock Gating Selection</toolTipHelpDescription>
    <item name="Disable Gating of RTC Clock" evalFunction="&#xD;&#xA;&#x9;        function ForwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var value = SCM.getIntValue(currentResource);&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_rtc/cgat_clr&quot;);&#xD;&#xA;&#x9;          if (value == 1 ) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,1);      &#xD;&#xA;&#x9;          } else if (value === 0) {&#xD;&#xA;&#x9;            SCM.setIntValue(Res0,0);&#xD;&#xA;&#x9;          }              &#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;        function BackwardMapping()&#xD;&#xA;&#x9;        {&#xD;&#xA;&#x9;          var Res0 = SCM.getResource(&quot;clkgating_rtc/cgat_clr&quot;);&#xD;&#xA;&#x9;          var value0 = SCM.getIntValue(Res0);&#xD;&#xA;&#x9;          if (value0 === 1) { &#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,1);&#xD;&#xA;&#x9;          } &#xD;&#xA;&#x9;          else {&#xD;&#xA;&#x9;            SCM.setIntValue(currentResource,0);&#xD;&#xA;&#x9;          }&#xD;&#xA;&#x9;        }&#xD;&#xA;&#x9;      " URI="http://www.infineon.com/1.0.8/app/clk002/0/clk002_erwsswclockgatingrtc/0" downWardmappedList="//@consumed.43" maxValue="1" minValue="0">
      <defaultValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <localValue xsi:type="ResourceModel:StringValue" value="0"/>
      <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
      <toolTipHelpDescription>Disable Gating of RTC Clock</toolTipHelpDescription>
    </item>
  </provided>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk_uri">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../SCU/SCU_0.dd#//@provided.0"/>
    <requiredResource uriString="peripheral/scu/0/ccu/config" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_vadcshs">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../SCU/SCU_0.dd#//@provided.6"/>
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/vadcshs" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;var value = Solver.getSoftwareId();&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;if (&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;(value == &quot;13.0101.10&quot;)||(value == &quot;13.0101.11&quot;)||(value == &quot;13.0101.9&quot;)||&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;(value == &quot;13.0101.7&quot;)||(value == &quot;13.0102.10&quot;)||(value == &quot;13.0102.11&quot;)|| &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;(value == &quot;13.0102.9&quot;)||(value == &quot;13.0102.7&quot;)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9; {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;         return true;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;     } &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9; return false;&#xD;&#xA;&#x9;&#x9;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_ccu8">
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/ccu8/0" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_ccu4">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../SCU/SCU_0.dd#//@provided.8"/>
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/ccu4/0" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_usic">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../SCU/SCU_0.dd#//@provided.10"/>
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/usic/0" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;var value = Solver.getSoftwareId();&#x9;//check for all 13.0101.10, 13.0101.11 series IDs&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;var value1 = Solver.getSoftwareId().substring(0,2).compareTo(&quot;11&quot;);&#x9;&#x9;//check for all 11.XXXX.X series IDs&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;if ( (value == &quot;13.0101.10&quot;) || (value == &quot;13.0101.11&quot;) || (value == &quot;12.0101.11&quot;) || (value1 == 0) ) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9; {&#x9;//No BCCU for 11X and 13.0101.X device ids&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;         return false;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;     } &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9; return true;&#xD;&#xA;&#x9;&#x9;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_bccu">
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/bccu/0" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;                var value = Solver.getSoftwareId();&#xD;&#xA;&#x9;&#x9;                if((value  == &quot;12.0101.7&quot;) || (value  == &quot;12.0101.8&quot;) || (value  == &quot;12.0101.11&quot;)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;|| (value  == &quot;12.0100.7&quot;)) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;{//LEDTS gating only for devices with the above id.&#xD;&#xA;&#x9;&#x9;                  return true;&#xD;&#xA;&#x9;&#x9;                }&#xD;&#xA;&#x9;&#x9;                return false;&#xD;&#xA;&#x9;&#x9;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_ledts0">
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/ledts/0" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;                var value = Solver.getSoftwareId();&#xD;&#xA;&#x9;&#x9;                if((value  == &quot;12.0101.7&quot;) || (value  == &quot;12.0101.8&quot;) || (value  == &quot;12.0101.11&quot;)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;|| (value  == &quot;12.0100.7&quot;)) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;{//LEDTS gating only for devices with the above id.&#xD;&#xA;&#x9;&#x9;                  return true;&#xD;&#xA;&#x9;&#x9;                }&#xD;&#xA;&#x9;&#x9;                return false;&#xD;&#xA;&#x9;&#x9;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_ledts1">
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/ledts/1" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;var value1 = Solver.getSoftwareId().substring(0,2).compareTo(&quot;13&quot;);&#x9;&#x9;//check for all 13.XXXX.X series IDs&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;if (value == 0)  &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9; {&#x9;//POSIF only for 13X device ids &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;         return true;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;     } &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9; return false;&#xD;&#xA;&#x9;&#x9;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_posif">
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/posif/0" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;                var value1 = Solver.getSoftwareId();&#xD;&#xA;&#x9;&#x9;                if(&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;(value1  == &quot;12.0103.9&quot;) || (value1  == &quot;13.0102.7&quot;) || (value1  == &quot;13.0102.9&quot;)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;|| (value1  == &quot;13.0102.10&quot;) || (value1  == &quot;13.0102.11&quot;)&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;) &#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;{&#xD;&#xA;&#x9;&#x9;&#x9;                  return true;&#xD;&#xA;&#x9;&#x9;&#x9;                }&#xD;&#xA;&#x9;&#x9;&#x9;                return false;&#xD;&#xA;&#x9;&#x9;            }" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_math">
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/math" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_wdt">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../SCU/SCU_0.dd#//@provided.12"/>
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/wdt" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_rtc">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../SCU/SCU_0.dd#//@provided.14"/>
    <requiredResource uriString="peripheral/scu/0/ccu/clkgating/rtc" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var rtcres = Solver.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var val = Solver.getIntValue(rtcres);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if(val  == 0) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  return true;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return false;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}" URI="http://www.infineon.com/1.0.8/app/clk002/0/dco_uri">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../SCU/SCU_0.dd#//@provided.16"/>
    <requiredResource uriString="peripheral/scu/0/dco/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var rtcres = Solver.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var val = Solver.getIntValue(rtcres);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if(val  == 1) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  return true;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return false;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}" URI="http://www.infineon.com/1.0.8/app/clk002/0/eruapp" upWardMappingList="//@provided.7 //@provided.7/@item.0 //@provided.7/@item.1 //@provided.7/@item.2">
    <localValue xsi:type="ResourceModel:StringValue" value="DependentApp"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="DependentApp"/>
    <requiredResource uriString="app/eru002/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" evalFunction="function resourceCondition() {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var rtcres = Solver.getResource(&quot;rtc_clockseldummy&quot;);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;var val = Solver.getIntValue(rtcres);&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;if(val  == 2) {&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;  return true;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;}&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;&#x9;return false;&#xD;&#xA;&#x9;&#x9;&#x9;&#x9;}" URI="http://www.infineon.com/1.0.8/app/clk002/0/analogcompapp" upWardMappingList="//@provided.7 //@provided.7/@item.0 //@provided.7/@item.1 //@provided.7/@item.2">
    <localValue xsi:type="ResourceModel:StringValue" value="DependentApp"/>
    <globalValue xsi:type="ResourceModel:StringValue" value="DependentApp"/>
    <requiredResource uriString="app/anacmp01/*" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/actualpclk" upWardMappingList="//@provided.2/@item.0 //@provided.3" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="20"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="20"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/actualmclk" upWardMappingList="//@provided.2/@item.0 //@provided.3" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="20"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="20"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/inputfreq" upWardMappingList="//@provided.2/@item.0 //@provided.3 //@provided.4 //@provided.6" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="7d00"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="7d00"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/rtc_clockseldummy" upWardMappingList="//@provided.7 //@provided.7/@item.0 //@provided.7/@item.1 //@provided.7/@item.2" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/pclkselbit" upWardMappingList="//@provided.2/@item.0 //@provided.2/@item.1 //@provided.3 //@provided.4 //@provided.6" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/sswactualpclk" upWardMappingList="//@provided.8/@item.0 //@provided.9" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="8"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="8"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/sswactualmclk" upWardMappingList="//@provided.8/@item.0 //@provided.9" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="8"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="8"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/sswidiv" upWardMappingList="//@provided.8/@item.0 //@provided.9" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="4"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/sswfdiv" upWardMappingList="//@provided.8/@item.0 //@provided.9" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/sswpclksel" upWardMappingList="//@provided.8 //@provided.8/@item.0 //@provided.8/@item.1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/sswinputfreq" upWardMappingList="//@provided.8/@item.0 //@provided.9 //@provided.10 //@provided.11" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1f40"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1f40"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/sswpclkselbit" upWardMappingList="//@provided.8/@item.0 //@provided.8/@item.1 //@provided.9 //@provided.10 //@provided.11" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/sswrtcclksel" upWardMappingList="//@provided.12 //@provided.12/@item.0 //@provided.12/@item.1 //@provided.12/@item.2 //@provided.12/@item.3 //@provided.12/@item.4" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <requiredResource uriString="" uriType="LOCALTYPE"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/dco_uri" isSystemDefined="true">
    <downWardmappedList xsi:type="ResourceModel:ResourceGroup" href="../../SCU/SCU_0.dd#//@provided.16"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk_uri/clkcr/pclksel" upWardMappingList="//@provided.2 //@provided.2/@item.0 //@provided.2/@item.1" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.1"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk_uri/clkcr/idiv" upWardMappingList="//@provided.2/@item.0 //@provided.3" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="1"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.2"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="1"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk_uri/clkcr/fdiv" upWardMappingList="//@provided.2/@item.0 //@provided.3" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.3"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk_uri/clkcr/rtcclksel" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.4"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_vadcshs/cgat_clr" upWardMappingList="//@provided.13/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.7"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_ccu8/cgat_clr" upWardMappingList="//@provided.14/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_ccu4/cgat_clr" upWardMappingList="//@provided.15/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.9"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_usic/cgat_clr" upWardMappingList="//@provided.16/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.11"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_bccu/cgat_clr" upWardMappingList="//@provided.17/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_ledts0/cgat_clr" upWardMappingList="//@provided.18/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_ledts1/cgat_clr" upWardMappingList="//@provided.19/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_posif/cgat_clr" upWardMappingList="//@provided.20/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_math/cgat_clr" upWardMappingList="//@provided.21/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_wdt/cgat_clr" upWardMappingList="//@provided.22/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.13"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clkgating_rtc/cgat_clr" upWardMappingList="//@provided.23/@item.0" isSystemDefined="true">
    <localValue xsi:type="ResourceModel:IntegerValue" value="0"/>
    <downWardmappedList xsi:type="ResourceModel:BitField" href="../../SCU/SCU_0.dd#//@provided.15"/>
    <globalValue xsi:type="ResourceModel:IntegerValue" value="0"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/clk_uri/frtc" isSystemDefined="true">
    <downWardmappedList xsi:type="ResourceModel:SignalDeclaration" href="../../SCU/SCU_0.dd#//@provided.5"/>
  </consumed>
  <consumed xsi:type="ResourceModel:ProxyResource" URI="http://www.infineon.com/1.0.8/app/clk002/0/dco_uri/clkout" isSystemDefined="true">
    <downWardmappedList xsi:type="ResourceModel:SignalDeclaration" href="../../SCU/SCU_0.dd#//@provided.17"/>
  </consumed>
  <propertyConstants name="uriDevice" value="Device/">
    <propertyConstants name="uriAnalogCompApp" value="app/anacmp01/">
      <propertyConstants name="uriERUapp" value="app/eru002/">
        <propertyConstants name="uri_clockapp2" value="app/clk002/"/>
      </propertyConstants>
    </propertyConstants>
  </propertyConstants>
  <categoryDescription description="Peripheral Specific Apps" name="Peripheral Specific Apps">
    <subCategory description="CPU-System" name="CPU-System">
      <subCategory description="System control Unit (SCU)" name="System control Unit (SCU)"/>
    </subCategory>
  </categoryDescription>
  <manifestInfo version="1.0.8">
    <keywords>system clock</keywords>
    <keywords>pll</keywords>
    <keywords>CLK002</keywords>
    <keywords>Clock</keywords>
    <properties xsi:type="ResourceModel:AppProperties_1_0" initProvider="true" singleton="true"/>
  </manifestInfo>
  <datagenerate fileName="CLK002.h" fileType="HFILE" templateFileName="CLK002.hdt" templateEngine="NONE" fileAction="COPY"/>
  <datagenerate fileName="CLK002.c" templateFileName="CLK002c.jet"/>
  <datagenerate fileName="CLKVAL_SSW.h" fileType="HFILE" templateFileName="CLKVAL_SSWh.jet"/>
  <connections sourceSignal="app/clk002/0/clk002_clkout_vs" targetSignal="app/clk002/0/clk002_frtc_vs"/>
  <softwareIdList>11.00.7</softwareIdList>
  <softwareIdList>11.00.9</softwareIdList>
  <softwareIdList>12.00.7</softwareIdList>
  <softwareIdList>13.02.7</softwareIdList>
  <softwareIdList>11.0100.7</softwareIdList>
  <softwareIdList>11.0100.9</softwareIdList>
  <softwareIdList>12.0100.7</softwareIdList>
  <softwareIdList>13.0102.7</softwareIdList>
  <softwareIdList>12.0101.7</softwareIdList>
  <softwareIdList>12.0102.9</softwareIdList>
  <softwareIdList>12.0102.8</softwareIdList>
  <softwareIdList>13.0101.9</softwareIdList>
  <softwareIdList>13.0101.7</softwareIdList>
  <softwareIdList>11.0100.10</softwareIdList>
  <softwareIdList>11.0100.11</softwareIdList>
  <softwareIdList>12.0101.11</softwareIdList>
  <softwareIdList>12.0102.10</softwareIdList>
  <softwareIdList>12.0102.11</softwareIdList>
  <softwareIdList>13.0101.10</softwareIdList>
  <softwareIdList>13.0101.11</softwareIdList>
  <softwareIdList>13.0102.10</softwareIdList>
  <softwareIdList>13.0102.11</softwareIdList>
  <softwareIdList>13.0102.9</softwareIdList>
</ResourceModel:App>
