/**
  ******************************************************************************************
  * @file   	main.c
  * @brief  	C-Datei mit Hauptfunktion
  * @version	V1.0.0
  * @date   	2014/06/29
  * @author		Nico Schmidt, DD6VFS, nico.schmidt@longrisoft.de
  * 
  *  	description: -	Steuergert fr eine Magnetic-Loop Antenne o. .
	*							   		mit XMC1100 auf XMC 2Go-Board zur Teilnahme am 
	*										Infineon XMC Design Contest 2014.
	*                -	Erstellt mit Infinion DAVE 3 und Keil Vision 5.10
	*								 -	Verffentlicht unter CC BY-SA 2.0 DE
	*
	*******************************************************************************************                
  *	In dieser Datei befindet sich die Hauptfunktion main(), von der aus die Systeminitiali-
	* sierung, die Initialisierung und der Start des RTOS RTX vollzogen werden  
  *******************************************************************************************
*/

#include "main.h"

int main(void)
{
	
	system_init();					// System initialisieren
	
	osKernelInitialize();		// RTX-Kernel initialisieren
	osKernelStart ();				// RTX-Kernel starten

	while(1);						 		// Endlosschleife
}
