/**
  ******************************************************************************************
  * @file   	control.h
  * @brief  	Headerdatei mit Thread fr Steuerung der Abstimmung
	* @version	V1.0.0
  * @date   	2014/05/14
  * @author		Nico Schmidt
  * 
  *  	description: -	Steuergert fr eine Magnetic-Loop Antenne o. .
	*							   		mit XMC1100 auf XMC 2Go-Board zur Teilnahme am 
	*										Infineon XMC Design Contest 2014.
	*                -	Erstellt mit Infinion DAVE 3 und Keil Vision 5.10
	*								 -	Verffentlicht unter CC BY-SA 2.0 DE
	*
  *******************************************************************************************
*/

//------------------------------------- Prolog ----------------------------------------------- 
#ifndef __my_control_h										// __my_control_h noch nicht definiert?
																					// dann
#define __my_control_h										// definiere Makro __my_control_h

//------------------------------ Bentigte Header-Dateien einbinden ---------------------------
#include <DAVE3.h>												// DAVE3-Headers einbinden
#include "uart.h"													// UART-Header einbinden
#include "swr.h"													// SWR-Header einbinden

//---------------------------------- Prototypen der Funktionen --------------------------------
void control(void const *arg);						// Prototype Thread fr Steuerung	

//---------------------------------------------------------------------------------------------
#endif
