/**
  ******************************************************************************************
  * @file   	swr.h
  * @brief  	Headerdatei mit Threads fr SWR-Berechnung
	* @version	V1.0.0
  * @date   	2014/06/29
  * @author		Nico Schmidt
  * 
  *  	description: -	Steuergert fr eine Magnetic-Loop Antenne o. .
	*							   		mit XMC1100 auf XMC 2Go-Board zur Teilnahme am 
	*										Infineon XMC Design Contest 2014.
	*                -	Erstellt mit Infinion DAVE 3 und Keil Vision 5.10
	*								 -	Verffentlicht unter CC BY-SA 2.0 DE
  *
  *******************************************************************************************
*/

//------------------------------------- Prolog ----------------------------------------------- 
#ifndef __my_swr_h 												// __my_swr_h noch nicht definiert?
																					// dann
#define __my_swr_h												// definiere Makro __my_swr_h 

//------------------------------ Bentigte Header-Dateien einbinden ---------------------------
#include <DAVE3.h>												// fr DAVE3

//---------------------------------- Prototypen der Funktionen --------------------------------
void swr_messung(void const *arg);				// Thread fr SWR-Messung						

//---------------------------------- Makros und vorgegebene Werte -----------------------------
#define PIN_vor ADC004_ChannelAAHandle		// Kanal fr U_vor
#define PIN_zur ADC004_ChannelABHandle		// Kanal fr U_zurck
#define Min_Leistung 5UL									// Minimale Vorwrtspannung zu Verarbeitung
#define SWR_Max 1.2f											// Maximales SWR fr Ansprechen

//--------------------------------------- Strukturen ------------------------------------------
typedef struct														// Struktur fr SWR-Mailbox festlegen
{
	float SWR_Value;												// SWR als float
} SWR_Queue_struct;

//---------------------------------------------------------------------------------------------
#endif

