/**
  ******************************************************************************************
  * @file   	system_init.h
  * @brief  	Headerdatei fr Funktionen zur Systeminitialisierung
  * @version	V1.0.0
  * @date   	2014/06/29
  * @author		Nico Schmidt
  * 
  *  	description: -	Steuergert fr eine Magnetic-Loop Antenne o. .
	*							   		mit XMC1100 auf XMC 2Go-Board zur Teilnahme am 
	*										Infineon XMC Design Contest 2014.
	*                -	Erstellt mit Infinion DAVE 3 und Keil Vision 5.10
	*								 -	Verffentlicht unter CC BY-SA 2.0 DE
  *
  *******************************************************************************************
*/

//------------------------------------- Prolog ----------------------------------------------- 
#ifndef __my_system_init_h 								// __my_system_init_h noch nicht definiert?
																					// dann
#define __my_system_init_h								// definiere Makro __my_system_init_h 

//------------------------------ Bentigte Header-Dateien einbinden ---------------------------
#include <DAVE3.h>												// fr DAVE3
#include "uart.h"													// fr UART Behandlung
#include "swr.h"													// fr SWR-Messung und -Berechnung
#include "control.h"											// fr I/O-Steuerung
//---------------------------------- Prototypen der Funktionen --------------------------------
void system_init(void);										// Funktion zur Systeminitialisierung
void system_running (void const *arg);    // Thread zur Systemberwachung per Led

//---------------------------------------------------------------------------------------------
#endif

