/**
  ******************************************************************************************
  * @file   	uart.h
  * @brief  	Headerdatei fr Threads fr den UART
	* @version	V1.0.0
  * @date   	2014/06/29
  * @author		Nico Schmidt
  * 
  *  	description: -	Steuergert fr eine Magnetic-Loop Antenne o. .
	*							   		mit XMC1100 auf XMC 2Go-Board zur Teilnahme am 
	*										Infineon XMC Design Contest 2014.
	*                -	Erstellt mit Infinion DAVE 3 und Keil Vision 5.10
	*								 -	Verffentlicht unter CC BY-SA 2.0 DE
  *
  *******************************************************************************************
*/

//------------------------------------- Prolog ----------------------------------------------- 
#ifndef __my_uart_h 											// __my_uart_h noch nicht definiert?
																					// dann
#define __my_uart_h												// definiere Makro __my_uart_h

//------------------------------ Bentigte Header-Dateien einbinden ---------------------------
#include <DAVE3.h>												// fr DAVE3

//---------------------------------- Prototypen der Funktionen --------------------------------
void uart_transmit(void const *arg);			// Thread zum Senden per UART

//--------------------------------------- Strukturen ------------------------------------------
typedef struct														// Struktur fr UART-Mailboxen festlegen
{
	char Message[16];												// Lnge maximal 15+1 Bytes
	uint8_t	Lenght;													// Lnge der Daten
} Uart_Queue_struct;

//---------------------------------------------------------------------------------------------
#endif

